# Define our stages
stages:
  - test
  #- deploy

# Select what we should cache between builds
cache:
  key: vendor-cache
  paths:
  - vendor/

# Template for test jobs
.job_template: &job_definition
  stage: test
  services:
    # Bring in any services we need http://docs.gitlab.com/ee/ci/docker/using_docker_images.html#what-is-a-service
    # See http://docs.gitlab.com/ce/ci/services/README.html for examples.
    - mariadb:10.2

  variables:
    # Configure mariadb service https://hub.docker.com/_/mariadb/
    MYSQL_ROOT_PASSWORD: toor
    MYSQL_DATABASE: testdb
    MYSQL_USER: testuser
    MYSQL_PASSWORD: testpass

  # What we want execute BEFORE the jobs
  before_script:
    #- apt-get update -yqq > /dev/null
    #- apt-get install -yqq git mysql-client libmcrypt-dev libpq-dev libcurl4-gnutls-dev libicu-dev libvpx-dev libjpeg-dev libpng-dev libxpm-dev zlib1g-dev libfreetype6-dev libxml2-dev libexpat1-dev libbz2-dev libgmp3-dev libldap2-dev unixodbc-dev libsqlite3-dev libaspell-dev libsnmp-dev libpcre3-dev libtidy-dev >/dev/null 2>&1 &
    # Install PHP extensions
    - docker-php-ext-install mbstring pdo_pgsql pdo_mysql curl json intl gd xml zip bz2 opcache > /dev/null
    # Install & enable Xdebug for code coverage reports
    - pecl install xdebug >/dev/null
    - docker-php-ext-enable xdebug
    # Install and run Composer
    - curl -sS https://getcomposer.org/installer | php
    - php composer.phar install
    # Set mysql connection parameters
    - cp app/src/settings.php app/src/settings.local.php
    - sed -i "s/INFO/DEBUG/g;s/__DEBUG__/true/g;s/__DB_DRIVER__/mysql/g;s/__DB_HOST__/mariadb/g;s/__DB_NAME__/"$MYSQL_DATABASE"/g;s/__DB_USER__/"$MYSQL_USER"/g;s/__DB_PASS__/"$MYSQL_PASSWORD"/g" app/src/settings.local.php
    # load db data
    - mysql -u $MYSQL_USER --password="$MYSQL_PASSWORD" -h mariadb $MYSQL_DATABASE < sql/struct.sql
    - mysql -u $MYSQL_USER --password="$MYSQL_PASSWORD" -h mariadb $MYSQL_DATABASE < sql/sample_data.sql
    # run php builtin -> TODO: nginx+php-fpm
    - php -S 0.0.0.0:8080 -t app/public/ >/dev/null 2>&1 &

# # Run our tests
# # If Xdebug was installed you can generate a coverage report and see code coverage metrics.
# test:php7.0:
#   <<: *job_definition
#   stage: test
#   # Select image from https://hub.docker.com/_/php/
#   image: php:7.0.29

#   script:
#     - php vendor/bin/phpmd app/src text phpmd.xml
#     - php vendor/bin/phpmetrics --report-html=build/phpmetric-report app/src
#     - php vendor/bin/phpunit --configuration phpunit_ci.xml --coverage-text --colors=never

#   allow_failure: true

# If Xdebug was installed you can generate a coverage report and see code coverage metrics.
test:php7.1:
  <<: *job_definition
  stage: test
  # Select image from https://hub.docker.com/_/php/
  image: php:7.1.16

  script:
    - php vendor/bin/phpmd app/src html phpmd.xml
    - php vendor/bin/phpmetrics --report-html=build/phpmetric-report app/src
    - php vendor/bin/phpunit --configuration phpunit_ci.xml --coverage-html --colors=never
  artifacts:
    paths:
    - build/
  only:
    - master
    - devel

# # If Xdebug was installed you can generate a coverage report and see code coverage metrics.
# test:php7.2:
#   <<: *job_definition
#   stage: test
#   # Select image from https://hub.docker.com/_/php/
#   image: php:7.2.4

#   script:
#     - php vendor/bin/phpmd app/src text phpmd.xml
#     - php vendor/bin/phpmetrics --report-html=build/phpmetric-report app/src
#     - php vendor/bin/phpunit --configuration phpunit_ci.xml --coverage-text --colors=never
#   artifacts:
#     paths:
#     - build/
#   allow_failure: true

deploy_demo:
  stage: deploy
  image: debian:9.4-slim
  script:
    - apt-get -qq update -y > /dev/null
    - apt-get -qq update -y
    - apt-get -qq install -y openssh-client git > /dev/null
    # run ssh-agent
    - eval $(ssh-agent -s)
    # add ssh key from ci secrets envars
    # RSA Key
    - ssh-add - <<<"$SSH_KEY_DEMO" > /dev/null
    # ECDSA key
    # - echo "$SSH_KEY_DEMO" | tr -d '\r' | ssh-add - > /dev/null
    - ssh -o StrictHostKeyChecking=no -p $SSH_PORT_DEMO $SSH_USER_DEMO@demo.firegarden.co sh deploy-demo.sh &>/dev/null
    - echo yay
  environment:
    name: demo
    url: https://demo.firegarden.co
  # when: manual
  only:
  - master
